function runprobCRF(nNodes)

[funObj,tau,groups,weights] = genprobCRF(nNodes);

funProjTau = GroupOneNormProject(groups,weights,1);
funProj    = @(x) funProjTau(x,tau);

%% SPG
opts.curvilinear = 1; % Projected backtracking
opts.spectral    = 1; % Enable Barzilai-Borwein
opts.maxfunc = 1000;
[x2,g,info2] = spg( funObj, funProj, zeros(length(groups),1),opts);

%% Get lambda from tau and solution
[f,g] = funObj(x2);
gGroupInf = sqrt(accumarray(groups,g.^2));
lambda = max(gGroupInf(2:end)./weights(2:end)); % Group 1 is the unpenalized elements


%% PG
opts.curvilinear = 1; % Projected backtracking
opts.spectral    = 0; % Disable Barzilai-Borwein
opts.history     = 1; % Monotone iterations
[x3,g,info3] = spg( funObj, funProj, zeros(length(groups),1),opts);

%% BGS
opts.bgstol = 1e-4;
[x1,info1] = bgs(funObj,lambda,groups,weights,opts);

%% EpsL1
opts.epsl1tol = 1e-12;
[x4,info4] = epsl1(funObj,lambda,groups,weights,opts);

% Store the results
[pathstr,name,ext,versn] = fileparts(mfilename('fullpath'));
filename = sprintf('%s%sdata%sprobCRF%03d.mat',...
                   pathstr,filesep,filesep,nNodes)

fmt = 'save %s x1 x2 x3 x4 info1 info2 info3 info4 tau lambda groups weights';
cmd = sprintf(fmt,filename);
evalc(cmd);
