function [yMAP] = UGM_decode(wv,X,Xedge,edgeStruct,infoStruct,decodeFunc,varargin)
[nInstances,nFeatures,nNodes] = size(X);
nEdges = size(Xedge,3);
nStates = max(infoStruct.nStates);

% Compute potentials
[w,v] = UGM_splitWeights(wv,infoStruct);
nodePot = UGM_makeNodePotentials(X,w,infoStruct);
edgePot = UGM_makeEdgePotentials(Xedge,v,edgeStruct,infoStruct);

if length(unique(X)) == 1 && (length(unique(Xedge)) == 1 || isempty(Xedge))
    % For MRFs, we only do decoding once
    MAP = decodeFunc(nodePot(:,:,1),edgePot(:,:,:,1),edgeStruct,infoStruct,varargin{:});
    yBel = zeros(nInstances,nNodes,nStates);
    for n = 1:nNodes
        yMAP(:,n) = MAP(n);
    end
else
    % CRF, do decoding on every example
    for i = 1:nInstances
        MAP = decodeFunc(nodePot(:,:,i),edgePot(:,:,:,i),edgeStruct,infoStruct,varargin{:});

        for n = 1:nNodes
            yMAP(i,n) = MAP(n);
        end
    end

end