clear all
%rand('state',1);
%randn('state',1);
nInstances = 10;
nFeatures = 0;
nNodes = 16;
subModular = 0;
nStates = 2;
useMex = 0;


if 0 % Chain
    adj = fixed_Chain(nNodes);
elseif 0 % Tree
    adj = zeros(6);
    adj(1,2) = 1;
    adj(2,3) = 1;
    adj(3,4) = 1;
    adj(3,5) = 1;
    adj(5,6) = 1;
    adj = adj+adj';
elseif 1 % Random
    adj = 1;
else % Loop
    adj = fixed_Chain(nNodes);
    adj(nNodes,1) = 1;
    adj(1,nNodes) = 1;
end
tied = 0;
ising = 1;


clear blocks
if 0
    % 1 Block consisting of all nodes
    blocks{1} = 1:nNodes;
elseif 0
    % Each node in a separate block
    for b = 1:nNodes
        blocks{b} = b;
    end
elseif 1
    % Two Blocks, each containing half the nodes
    blocks{1} = 1:ceil(nNodes/2);
    blocks{2} = ceil(nNodes/2)+1:nNodes;
elseif 0
    blocks{1} = 1:4:nNodes;
    blocks{2} = 2:4:nNodes;
    blocks{3} = 3:4:nNodes;
    blo1ks{4} = 4:4:nNodes;
end
cutset = [3 5];
maxIter = 1000;

% Get some data and an adjacency matrix
fprintf('Sampling from CRF Model...\n');
[y,adjMatrix,X] = UGM_generate(nInstances,nFeatures,nNodes,adj,nStates,ising,tied,0,10);
fprintf('Done Sampling\n');

% Make edges from adjacency matrix
edgeStruct=UGM_makeEdgeStruct(adjMatrix);
nEdges = edgeStruct.nEdges;

% Make edge features
if subModular
    Xedge = UGM_makeEdgeFeaturesInvAbsDif(X,edgeStruct.edgeEnds);
else
    Xedge = UGM_makeEdgeFeatures(X,edgeStruct.edgeEnds);
end

% Add bias to each node and edge
X = [ones(nInstances,1,nNodes) X];
Xedge = [ones(nInstances,1,nEdges) Xedge];

% Make Infostruct
infoStruct = UGM_makeInfoStruct(X,Xedge,edgeStruct,nStates,ising,tied,useMex,maxIter);

% Initialize weights
[w,v] = UGM_initWeights(infoStruct,'random');
if subModular
    v(v < 0) = 0;
end

i = 1;
% Make node potentials for first example
nodePot = UGM_makeNodePotentials(X(i,:,:),w,infoStruct);

% Make edge potentials for first example
edgePot = UGM_makeEdgePotentials(Xedge(i,:,:),v,edgeStruct,infoStruct);

if 0 % Example of clamping
    edgePot
    nodePot
    clamped = zeros(nNodes,1);
    clamped(1) = 1;
    clamped(3) = 2;
    [nodePot,edgePot,edgeStruct,infoStruct] = UGM_makeClampedPotentials(nodePot, edgePot, edgeStruct, infoStruct, clamped)
    pause;
end

% Do inference
%[nodeBel,edgeBel,logZ] = UGM_Infer_Exact(nodePot,edgePot,edgeStruct,infoStruct);
%[nodeBel2,edgeBel2,logZ2] = UGM_Infer_LBP(nodePot,edgePot,edgeStruct,infoStruct);
%[nodeBel3,edgeBel3,logZ3] = UGM_Infer_Sample(nodePot,edgePot,edgeStruct,infoStruct,@UGM_Sample_Gibbs);
%[nodeBel4,edgeBel4,logZ4] = UGM_Infer_MF(nodePot,edgePot,edgeStruct,infoStruct);
%[nodeBel5,edgeBel5,logZ5] = UGM_Infer_Chain(nodePot,edgePot,edgeStruct,infoStruct);
% [nodeBel6,edgeBel6,logZ6] =
% UGM_Infer_Sample_Importance(nodePot,edgePot,edgeStruct,infoStruct);
%[nodeBel7,edgeBel7,logZ7] = UGM_Infer_Sample(nodePot,edgePot,edgeStruct,infoStruct,@UGM_Sample_Chain);
% [nodeBel8,edgeBel8,logZ8] = UGM_Infer_Tree(nodePot,edgePot,edgeStruct,infoStruct);
%[nodeBel9,edgeBel9,logZ9] = UGM_Infer_Sample(nodePot,edgePot,edgeStruct,infoStruct,@UGM_Sample_Tree);
%[nodeBel10,edgeBel10,logZ10] =
%UGM_Infer_ViterbiApx(nodePot,edgePot,edgeStruct,infoStruct,@UGM_Decode_Exact);
%[nodeBel11,edgeBel11,logZ11] = UGM_Infer_Block_MF(nodePot,edgePot,edgeStruct,infoStruct,blocks,@UGM_Infer_Exact);
%[nodeBel12,edgeBel12,logZ12] = UGM_Infer_Cutset(nodePot,edgePot,edgeStruct,infoStruct,cutset);
%[nodeBel13,edgeBel13,logZ13] = UGM_Infer_Sample(nodePot,edgePot,edgeStruct,infoStruct,@UGM_Sample_Exact);
%[nodeBel14,edgeBel14,logZ14] = UGM_Infer_Sample(nodePot,edgePot,edgeStruct,infoStruct,@UGM_Sample_Block_Gibbs,blocks,@UGM_Sample_Exact);
%[nodeBel15,edgeBel15,logZ15] = UGM_Infer_Sample(nodePot,edgePot,edgeStruct,infoStruct,@UGM_Sample_Block_Gibbs,blocks,@UGM_Sample_Tree);
%[nodeBel16,edgeBel16,logZ16] = UGM_Infer_TRBP(nodePot,edgePot,edgeStruct,infoStruct);


% Calculate Most Likely Assignment
nodeLabels = UGM_Decode_Exact(nodePot,edgePot,edgeStruct,infoStruct);
nodeLabels2 = UGM_Decode_ICM(nodePot,edgePot,edgeStruct,infoStruct)
%nodeLabels3 = UGM_Decode_Sample(nodePot,edgePot,edgeStruct,infoStruct,@UGM_Sample_Gibbs)
%nodeLabels3a = UGM_Decode_SA(nodePot,edgePot,edgeStruct,infoStruct);
nodeLabels4 = UGM_Decode_Greedy(nodePot,edgePot,edgeStruct,infoStruct);
%nodeLabels5 = UGM_Decode_Chain(nodePot,edgePot,edgeStruct,infoStruct)
%nodeLabels6 = UGM_Decode_Tree(nodePot,edgePot,edgeStruct,infoStruct)
%nodeLabels7 = UGM_Decode_LBP(nodePot,edgePot,edgeStruct,infoStruct)
%nodeLabels8 = UGM_Decode_Block_ICM(nodePot,edgePot,edgeStruct,infoStruct,blocks,@UGM_Decode_Exact)
%nodeLabelsx = UGM_Decode_Block_ICM(nodePot,edgePot,edgeStruct,infoStruct,blocks2,@UGM_Decode_Exact)
%nodeLabels9 = UGM_Decode_Block_SA(nodePot,edgePot,edgeStruct,infoStruct,blocks);
%nodeLabels10 = UGM_Decode_MPM(nodePot,edgePot,edgeStruct,infoStruct,@UGM_Infer_Exact);
%nodeLabels11 = UGM_Decode_Sample(nodePot,edgePot,edgeStruct,infoStruct,@UGM_Sample_Block_Gibbs,blocks,@UGM_Sample_Exact)
%nodeLabels12 = UGM_Decode_LP(nodePot,edgePot,edgeStruct,infoStruct)
%nodeLabels13 = UGM_Decode_Cutset(nodePot,edgePot,edgeStruct,infoStruct,cutset)
%nodeLabels14 = UGM_Decode_TRBP(nodePot,edgePot,edgeStruct,infoStruct)
nodeLabels15 = UGM_Decode_LS(nodePot,edgePot,edgeStruct,infoStruct)
[nodeLabels nodeLabels2 nodeLabels4 nodeLabels15]
[UGM_ConfigurationPotential(nodeLabels,nodePot,edgePot,edgeStruct.edgeEnds);
UGM_ConfigurationPotential(nodeLabels2,nodePot,edgePot,edgeStruct.edgeEnds);
UGM_ConfigurationPotential(nodeLabels4,nodePot,edgePot,edgeStruct.edgeEnds);
UGM_ConfigurationPotential(nodeLabels15,nodePot,edgePot,edgeStruct.edgeEnds)]
return;

% Generate Samples
%samples = UGM_Sample_Exact(nodePot,edgePot,edgeStruct,infoStruct);
%samples2 = UGM_Sample_Gibbs(nodePot,edgePot,edgeStruct,infoStruct);
%samples3 = UGM_Sample_Chain(nodePot,edgePot,edgeStruct,infoStruct);
%samples4 = UGM_Sample_Tree(nodePot,edgePot,edgeStruct,infoStruct);
%samples5 = UGM_Sample_Block_Gibbs(nodePot,edgePot,edgeStruct,infoStruct,blocks,@UGM_Sample_Exact);
%samples6 = UGM_Sample_MF(nodePot,edgePot,edgeStruct,infoStruct);
%samples7 = UGM_Sample_MH(nodePot,edgePot,edgeStruct,infoStruct);
%samples8 = UGM_Sample_VarMCMC(nodePot,edgePot,edgeStruct,infoStruct,.9);
%[nodeBel(:,2) mean(samples-1,2) mean(samples4-1,2)]
%repmat(nodeBel(:,2),[1 3]) - ...
%   [nodeBel(:,2) mean(samples-1,2) mean(samples4-1,2)]
%pause;

% Calculate loss
wVect = w(infoStruct.wLinInd);
vVect = v(infoStruct.vLinInd);
UGM_Loss([wVect(:);vVect(:)],X,Xedge,y,edgeStruct,infoStruct,@UGM_Infer_Exact);

% Train to Minimize Joint Likelihood
options.DerivativeCheck = 'on';
options.numDiff = 0;
% [wv] = minFunc(@UGM_Loss,[wVect(:);vVect(:)],options,X,Xedge,y,edgeStruct,infoStruct,@UGM_Infer_Block_MF,blocks,@UGM_Infer_Exact);

% Train to Minimize Joint Likelihood with Stochastic Gradient
% options.mu = [1 .1 .01 .001 .0001];
% options.maxIter = 5000;
% [wv] = UGM_SGD(@UGM_Loss,[wVect(:);vVect(:)],options,X,Xedge,y,edgeStruct,infoStruct,@UGM_Infer_Exact);
% UGM_Loss(wv,X,Xedge,y,edgeStruct,infoStruct,@UGM_Infer_Exact)
% pause;

% Train to Minimze Pseudo Likelihood
[wv] = minFunc(@UGM_PseudoLoss,[wVect(:);vVect(:)],options,X,Xedge,y,edgeStruct,infoStruct);
infoStruct.useMex = 0;
[wv] = minFunc(@UGM_PseudoLoss,[wVect(:);vVect(:)],options,X,Xedge,y,edgeStruct,infoStruct);
% options.Method = 'newton';
% options.DerivativeCheck = 'on';
% options.useComplex = 0;
% %options.numDiff = 0;
% [wv] = minFunc(@UGM_PseudoLoss,[wVect(:);vVect(:)],options,X,Xedge,y,edgeStruct,infoStruct);
