function [x] = generateData(type,nElements,param)
% type:
%   0 - randn
%   1 - randn + 'param'
%   2 - exponential random variable with rate 'param'

if type == 1
    % randn
    x = randn(nElements,1);
elseif type == 2
    % randn + offset
    x = randn(nElements,1) + param;
else
    % exponential random variable
    x = icdf('exp',rand(nElements,1),param);
end